VERSION 5.00
Begin VB.Form frmAddRule 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Add Rule"
   ClientHeight    =   4650
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5490
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   177
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4650
   ScaleWidth      =   5490
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkAcceptingRule 
      Caption         =   "Accepting Rule"
      Height          =   210
      Left            =   240
      TabIndex        =   7
      Top             =   2640
      Width           =   1455
   End
   Begin VB.TextBox txtComment 
      Height          =   315
      Left            =   240
      TabIndex        =   8
      Top             =   3360
      Width           =   3135
   End
   Begin VB.TextBox txtNewCellValue 
      Height          =   315
      Left            =   4080
      TabIndex        =   1
      Top             =   2400
      Width           =   1215
   End
   Begin VB.TextBox txtCurrentCellValue 
      Height          =   315
      Left            =   4080
      TabIndex        =   0
      Top             =   2040
      Width           =   1215
   End
   Begin VB.ComboBox cmbNewDirection 
      Height          =   330
      Left            =   2280
      Style           =   2  'Dropdown List
      TabIndex        =   6
      Top             =   2160
      Width           =   855
   End
   Begin VB.TextBox txtSteps 
      Height          =   255
      Left            =   1200
      TabIndex        =   5
      Top             =   2160
      Width           =   495
   End
   Begin VB.ComboBox cmbNewState 
      Height          =   330
      Left            =   1560
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   1680
      Width           =   2055
   End
   Begin VB.ComboBox cmbNewCellValue 
      Height          =   330
      Left            =   2280
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   1200
      Width           =   495
   End
   Begin VB.ComboBox cmbCurrentCellValue 
      Height          =   330
      Left            =   2520
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   720
      Width           =   495
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   495
      Left            =   960
      TabIndex        =   9
      Top             =   3960
      Width           =   1695
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   495
      Left            =   2880
      TabIndex        =   10
      Top             =   3960
      Width           =   1695
   End
   Begin VB.Label lblComment 
      AutoSize        =   -1  'True
      Caption         =   "Comment"
      Height          =   210
      Left            =   240
      TabIndex        =   18
      Top             =   3120
      Width           =   660
   End
   Begin VB.Label lblCurrentStateID 
      AutoSize        =   -1  'True
      Caption         =   "CurrentState"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   210
      Left            =   2400
      TabIndex        =   17
      Top             =   240
      Width           =   1065
   End
   Begin VB.Label lblSteps 
      AutoSize        =   -1  'True
      Caption         =   "steps"
      Height          =   210
      Left            =   1800
      TabIndex        =   16
      Top             =   2160
      Width           =   405
   End
   Begin VB.Label lblNewDirection 
      AutoSize        =   -1  'True
      Caption         =   "5. And move"
      Height          =   210
      Left            =   240
      TabIndex        =   15
      Top             =   2160
      Width           =   915
   End
   Begin VB.Label lblNewState 
      AutoSize        =   -1  'True
      Caption         =   "4. Move to state"
      Height          =   210
      Left            =   240
      TabIndex        =   14
      Top             =   1680
      Width           =   1155
   End
   Begin VB.Label lblNewCellValue 
      AutoSize        =   -1  'True
      Caption         =   "3. Change the cell value to"
      Height          =   210
      Left            =   240
      TabIndex        =   13
      Top             =   1200
      Width           =   1905
   End
   Begin VB.Label lblCurrentCellValue 
      AutoSize        =   -1  'True
      Caption         =   "2. And the current cell value is"
      Height          =   210
      Left            =   240
      TabIndex        =   12
      Top             =   720
      Width           =   2205
   End
   Begin VB.Label lblCurrentState 
      AutoSize        =   -1  'True
      Caption         =   "1. When the current state is"
      Height          =   210
      Left            =   240
      TabIndex        =   11
      Top             =   240
      Width           =   2010
   End
End
Attribute VB_Name = "frmAddRule"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public gstrCurrentStateID As String
Public gclsCurrentState As clsDFAState
Public gclsDFA As clsDFA

' The rule's properties, as entered by the user.
Public gstrCurrentCellValue As String
Public gstrNewCellValue As String
Public gstrNewStateID As String
Public gintNewDirection As Integer
Public gstrComment As String
Public gblnAcceptingRule As Boolean

Private Sub cmdCancel_Click()
    gstrCurrentCellValue = ""
    gstrNewCellValue = ""
    gstrNewStateID = ""
    gintNewDirection = 0
    gstrComment = ""
    
    Unload Me
End Sub

Private Sub cmdOK_Click()
    Dim intSteps As Integer
    Dim blnErrRaised As Boolean
    
    On Error GoTo ErrHandler
    
    If (gclsDFA.ReadHeadCanMoveSeveralSteps = True) Then
        intSteps = CInt(Trim$(txtSteps.Text))
        
        ' The steps textbox has a non-integer value.
        If ((blnErrRaised) Or (intSteps < 0)) Then _
            MsgBox "An invalid no. has been entered in the no. of steps the read head can move!", vbExclamation, "DFA Simulation": Exit Sub
        
        If ((intSteps = 0) And (Not gclsDFA.ReadHeadCanStayAtPosition)) Then _
            MsgBox "An invalid no. has been entered in the no. of steps the read head can move!", vbExclamation: Exit Sub
    Else
        intSteps = 1
    End If
        
    If ((txtCurrentCellValue.Text = "") And (gclsDFA.TextualTapeCellValues = True)) Then
        MsgBox "The " & IIf(gclsCurrentState Is Nothing, "new rule", "existing rule") & " has no current cell contents set.", vbExclamation, "DFA Simulation"
        Exit Sub
    ElseIf ((txtNewCellValue.Text = "") And (gclsDFA.TextualTapeCellValues = True)) Then
        MsgBox "The " & IIf(gclsCurrentState Is Nothing, "new rule", "existing rule") & " has no new cell contents set.", vbExclamation, "DFA Simulation"
        Exit Sub
    End If
        
    gintNewDirection = intSteps * IIf(cmbNewDirection.List(cmbNewDirection.ListIndex) = "Right", 1, -1)
    gstrCurrentCellValue = IIf(gclsDFA.TextualTapeCellValues = True, txtCurrentCellValue.Text, cmbCurrentCellValue.List(cmbCurrentCellValue.ListIndex))
    gstrNewCellValue = IIf(gclsDFA.TextualTapeCellValues = True, txtNewCellValue.Text, cmbNewCellValue.List(cmbNewCellValue.ListIndex))
    gstrNewStateID = cmbNewState.List(cmbNewState.ListIndex)
    gstrComment = txtComment.Text
    gblnAcceptingRule = IIf(gclsDFA.AllowAcceptingStates = True, chkAcceptingRule.Value, False)
    
    If (gclsCurrentState Is Nothing) Then
        ' State already exists.
        If (gclsDFA.DFAStateExists(gstrCurrentStateID, gstrCurrentCellValue)) Then _
            MsgBox "The current rule already exists!", vbExclamation, "DFA Simulation": Exit Sub
    Else
        ' State already exists.
        If ((gclsDFA.DFAStateExists(gstrCurrentStateID, gstrCurrentCellValue)) And _
            (gclsCurrentState.CurrentCellContents <> gstrCurrentCellValue)) Then _
            MsgBox "The current rule already exists!", vbExclamation, "DFA Simulation": Exit Sub
    End If
    
    Unload Me
    
    Exit Sub
    
ErrHandler:
    blnErrRaised = True
End Sub

Private Sub Form_Load()
    Dim colStates As Collection
    Dim clsCurrentState As clsDFAState
    Dim i As Integer, c As Integer
    
    If (gclsCurrentState Is Nothing) Then
        Me.Caption = "Add Rule"
    Else
        Me.Caption = "Edit Rule"
    End If
    
    lblCurrentState.Caption = "1. When in state "
    lblCurrentStateID.Caption = gstrCurrentStateID
    lblCurrentStateID.Top = lblCurrentState.Top
    lblCurrentStateID.Left = lblCurrentState.Left + lblCurrentState.Width
    
    lblCurrentCellValue.Top = lblCurrentState.Top + lblCurrentCellValue.Height + 200
    lblCurrentCellValue.Left = lblCurrentState.Left
    lblCurrentCellValue.Caption = "2. And the current cell value is "
    
    If (gclsDFA.TextualTapeCellValues = False) Then
        cmbCurrentCellValue.Clear
        cmbCurrentCellValue.Top = lblCurrentCellValue.Top - (cmbCurrentCellValue.Height - lblCurrentCellValue.Height) / 2
        cmbCurrentCellValue.Left = lblCurrentCellValue.Left + lblCurrentCellValue.Width
        
        cmbCurrentCellValue.AddItem "0"
        cmbCurrentCellValue.AddItem "1"
        If (gclsCurrentState Is Nothing) Then
            cmbCurrentCellValue.ListIndex = 0
        Else
            cmbCurrentCellValue.ListIndex = CInt(gclsCurrentState.CurrentCellContents)
        End If
            
        
        cmbCurrentCellValue.Visible = True
        txtCurrentCellValue.Visible = False
    Else
        txtCurrentCellValue.Top = lblCurrentCellValue.Top
        txtCurrentCellValue.Left = lblCurrentCellValue.Left + lblCurrentCellValue.Width
        If (gclsCurrentState Is Nothing) Then
            txtCurrentCellValue.Text = ""
        Else
            txtCurrentCellValue.Text = gclsCurrentState.CurrentCellContents
        End If
        
        cmbCurrentCellValue.Visible = False
        txtCurrentCellValue.Visible = True
    End If

    lblNewCellValue.Top = lblCurrentCellValue.Top + lblCurrentCellValue.Height + 200
    lblNewCellValue.Left = lblCurrentCellValue.Left
    lblNewCellValue.Caption = "3. Change the cell value to "
    
    If (gclsDFA.TextualTapeCellValues = False) Then
        cmbNewCellValue.Clear
        cmbNewCellValue.Top = lblNewCellValue.Top - (cmbNewCellValue.Height - lblNewCellValue.Height) / 2
        cmbNewCellValue.Left = lblNewCellValue.Left + lblNewCellValue.Width
        
        cmbNewCellValue.AddItem "0"
        cmbNewCellValue.AddItem "1"
        If (gclsCurrentState Is Nothing) Then
            cmbNewCellValue.ListIndex = 0
        Else
            cmbNewCellValue.ListIndex = CInt(gclsCurrentState.NewCellContents)
        End If
        
        cmbNewCellValue.Visible = True
        txtNewCellValue.Visible = False
    Else
        txtNewCellValue.Top = lblNewCellValue.Top
        txtNewCellValue.Left = lblNewCellValue.Left + lblNewCellValue.Width
        If (gclsCurrentState Is Nothing) Then
            txtNewCellValue.Text = ""
        Else
            txtNewCellValue.Text = gclsCurrentState.CurrentCellContents
        End If
        
        cmbNewCellValue.Visible = False
        txtNewCellValue.Visible = True
    End If

    lblNewState.Top = lblNewCellValue.Top + lblNewCellValue.Height + 200
    lblNewState.Left = lblNewCellValue.Left
    lblNewState.Caption = "4. Move to state "

    cmbNewState.Top = lblNewState.Top - (cmbNewState.Height - lblNewState.Height) / 2
    cmbNewState.Left = lblNewState.Left + lblNewState.Width
    
    cmbNewState.Clear
    
    c = 0
    
    For i = 1 To frmMain.lvwStates.ListItems.Count
        cmbNewState.AddItem frmMain.lvwStates.ListItems(i)
        If (Not (gclsCurrentState Is Nothing)) Then
            If (gclsCurrentState.NewStateID = frmMain.lvwStates.ListItems(i)) Then _
                c = i - 1
        Else
            If (gstrCurrentStateID = frmMain.lvwStates.ListItems(i)) Then _
                c = i - 1
        End If
    Next i

    cmbNewState.ListIndex = c
    
    If (gclsDFA.ReadHeadCanMoveSeveralSteps = False) Then
        
        lblNewDirection.Top = lblNewState.Top + lblNewState.Height + 200
        lblNewDirection.Left = lblNewState.Left
        lblNewDirection.Caption = "5. And move the read head "
        
        cmbNewDirection.Top = lblNewDirection.Top - (cmbNewDirection.Height - lblNewDirection.Height) / 2
        cmbNewDirection.Left = lblNewDirection.Left + lblNewDirection.Width
        
        cmbNewDirection.Clear
        cmbNewDirection.AddItem "Right"
        cmbNewDirection.AddItem "Left"
        If (gclsDFA.ReadHeadCanStayAtPosition = True) Then _
            cmbNewDirection.AddItem "Nowhere"
        
        If (gclsCurrentState Is Nothing) Then
            cmbNewDirection.ListIndex = 0
        Else
            If (gclsCurrentState.NewDirection > 0) Then
                cmbNewDirection.ListIndex = 0
            ElseIf (gclsCurrentState.NewDirection < 0) Then
                cmbNewDirection.ListIndex = 1
            Else
                If (gclsDFA.ReadHeadCanStayAtPosition = True) Then
                    cmbNewDirection.ListIndex = 2
                Else
                    cmbNewDirection.ListIndex = 0
                End If
            End If
        End If
        
        lblSteps.Visible = False
        txtSteps.Visible = False
        cmbNewDirection.Visible = True
        
    ElseIf ((gclsDFA.ReadHeadCanMoveSeveralSteps = True)) Then
        
        lblNewDirection.Top = lblNewState.Top + lblNewState.Height + 200
        lblNewDirection.Left = lblNewState.Left
        lblNewDirection.Caption = "5. And move the read head "
        
        txtSteps.Top = lblNewDirection.Top - (txtSteps.Height - lblNewDirection.Height) / 2
        txtSteps.Left = lblNewDirection.Left + lblNewDirection.Width
        If (gclsCurrentState Is Nothing) Then
            txtSteps.Text = "1"
        Else
            txtSteps.Text = gclsCurrentState.NewDirection
        End If
        
        lblSteps.Top = lblNewState.Top + lblNewState.Height + 200
        lblSteps.Left = txtSteps.Left + txtSteps.Width
        lblSteps.Caption = " step(s) "
        
        cmbNewDirection.Top = lblSteps.Top - (cmbNewDirection.Height - lblSteps.Height) / 2
        cmbNewDirection.Left = lblSteps.Left + lblSteps.Width
        
        cmbNewDirection.Clear
        cmbNewDirection.AddItem "Right"
        cmbNewDirection.AddItem "Left"
        cmbNewDirection.ListIndex = 0
        
        lblSteps.Visible = True
        txtSteps.Visible = True
        cmbNewDirection.Visible = True
    End If

    If (gclsDFA.AllowAcceptingStates = True) Then
        chkAcceptingRule.Visible = True
        chkAcceptingRule.Left = lblNewDirection.Left
        chkAcceptingRule.Top = lblNewDirection.Top + lblNewDirection.Height + 250
        
        If (gclsCurrentState Is Nothing) Then
            chkAcceptingRule.Value = False
        Else
            chkAcceptingRule.Value = Abs(gclsCurrentState.AcceptingState)
        End If
    
        lblComment.Left = chkAcceptingRule.Left
        lblComment.Top = chkAcceptingRule.Top + chkAcceptingRule.Height + 300
        
        txtComment.Left = lblComment.Left
        txtComment.Top = lblComment.Top + lblComment.Height + 50
        
        If (gclsCurrentState Is Nothing) Then
            txtComment.Text = ""
        Else
            txtComment.Text = gclsCurrentState.Comment
        End If
    Else
        chkAcceptingRule.Visible = False
    
        lblComment.Left = lblNewDirection.Left
        lblComment.Top = lblNewDirection.Top + lblNewDirection.Height + 300
        
        txtComment.Left = lblComment.Left
        txtComment.Top = lblComment.Top + lblComment.Height + 50
        
        If (gclsCurrentState Is Nothing) Then
            txtComment.Text = ""
        Else
            txtComment.Text = gclsCurrentState.Comment
        End If
    End If
End Sub
