VERSION 5.00
Begin VB.Form frmDFAProperties 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DFA Properties"
   ClientHeight    =   5985
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5190
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   177
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5985
   ScaleWidth      =   5190
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkReadHeadCanStayAtPosition 
      Caption         =   "Read head can stay at the same position"
      Height          =   210
      Left            =   360
      TabIndex        =   6
      Top             =   4560
      Width           =   3975
   End
   Begin VB.CheckBox chkReadHeadCanMoveSeveralSteps 
      Caption         =   "Read head can move more than one step left\right"
      Height          =   210
      Left            =   360
      TabIndex        =   5
      Top             =   4200
      Width           =   4215
   End
   Begin VB.CheckBox chkTextualCellValues 
      Caption         =   "Tape cells may contain values other than 0\1"
      Height          =   210
      Left            =   360
      TabIndex        =   4
      Top             =   3840
      Width           =   4095
   End
   Begin VB.CheckBox chkAllowAcceptingRules 
      Caption         =   "Allow accepting rules"
      Height          =   210
      Left            =   360
      TabIndex        =   3
      Top             =   3480
      Width           =   2535
   End
   Begin VB.TextBox txtDFADescription 
      Height          =   1125
      Left            =   360
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   2040
      Width           =   4455
   End
   Begin VB.TextBox txtDFAAuthor 
      Height          =   285
      Left            =   360
      TabIndex        =   1
      Top             =   1320
      Width           =   4455
   End
   Begin VB.TextBox txtDFAName 
      Height          =   285
      Left            =   360
      TabIndex        =   0
      Top             =   600
      Width           =   4455
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   495
      Left            =   720
      TabIndex        =   7
      Top             =   5280
      Width           =   1695
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   495
      Left            =   2640
      TabIndex        =   8
      Top             =   5280
      Width           =   1695
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Description"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   210
      Left            =   360
      TabIndex        =   11
      Top             =   1800
      Width           =   945
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Author"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   210
      Left            =   360
      TabIndex        =   10
      Top             =   1080
      Width           =   570
   End
   Begin VB.Label lblStateID 
      AutoSize        =   -1  'True
      Caption         =   "DFA Name"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   210
      Left            =   360
      TabIndex        =   9
      Top             =   360
      Width           =   825
   End
End
Attribute VB_Name = "frmDFAProperties"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public gclsDFA As clsDFA

Private Sub Form_Load()
    txtDFAName.Text = gclsDFA.DFAName
    txtDFAAuthor.Text = gclsDFA.DFAAuthor
    txtDFADescription.Text = gclsDFA.DFADescription
    
    chkAllowAcceptingRules.Value = Abs(gclsDFA.AllowAcceptingStates)
    chkTextualCellValues.Value = Abs(gclsDFA.TextualTapeCellValues)
    Me.chkReadHeadCanMoveSeveralSteps.Value = Abs(gclsDFA.ReadHeadCanMoveSeveralSteps)
    chkReadHeadCanStayAtPosition.Value = Abs(gclsDFA.ReadHeadCanStayAtPosition)
End Sub


Private Sub cmdOK_Click()
    If ((gclsDFA.AllowAcceptingStates = True) And (chkAllowAcceptingRules.Value = 0)) Then
        If (MsgBox("You've unchecked the 'Allow accepting rules' option." & vbCrLf & "This means that any accepting rules will no longer be accepting. Are you sure you want to continue?", vbQuestion Or vbYesNo, "DFA Simulation") = vbNo) Then _
            Exit Sub
    End If
    If ((gclsDFA.TextualTapeCellValues = True) And (chkTextualCellValues.Value = 0)) Then
        If (MsgBox("You've unchecked the 'Tape cells may contain values other than 0\1' option." & vbCrLf & "This means that any textual cell values will be set to zero. Are you sure you want to continue?", vbQuestion Or vbYesNo, "DFA Simulation") = vbNo) Then _
            Exit Sub
    End If
    If ((gclsDFA.ReadHeadCanMoveSeveralSteps = True) And (chkReadHeadCanMoveSeveralSteps.Value = 0)) Then
        If (MsgBox("You've unchecked the 'Read head can move more than one step left\right' option." & vbCrLf & "This means that any rules that move the read head several steps will now only move it one step left\right. Are you sure you want to continue?", vbQuestion Or vbYesNo, "DFA Simulation") = vbNo) Then _
            Exit Sub
    End If
    If ((gclsDFA.ReadHeadCanStayAtPosition = True) And (chkReadHeadCanStayAtPosition.Value = 0)) Then
        If (MsgBox("You've unchecked the 'Read head can stay at the same position' option." & vbCrLf & "This means that any rules that make the read head stay at the same position will now move it left. Are you sure you want to continue?", vbQuestion Or vbYesNo, "DFA Simulation") = vbNo) Then _
            Exit Sub
    End If

    gclsDFA.DFAName = txtDFAName.Text
    gclsDFA.DFAAuthor = txtDFAAuthor.Text
    gclsDFA.DFADescription = txtDFADescription.Text
    
    gclsDFA.AllowAcceptingStates = chkAllowAcceptingRules.Value
    gclsDFA.TextualTapeCellValues = chkTextualCellValues.Value
    gclsDFA.ReadHeadCanMoveSeveralSteps = chkReadHeadCanMoveSeveralSteps.Value
    gclsDFA.ReadHeadCanStayAtPosition = chkReadHeadCanStayAtPosition.Value
    
    Unload Me
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub
