VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmEditTape 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Edit Tape"
   ClientHeight    =   4215
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8640
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   177
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4215
   ScaleWidth      =   8640
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtTapeCells 
      Height          =   3615
      Left            =   1680
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   13
      Top             =   480
      Width           =   5295
   End
   Begin VB.CommandButton cmdSwitchEditMode 
      Caption         =   "Switch to Pure Text Tape Edit Mode"
      Height          =   735
      Left            =   120
      TabIndex        =   12
      Top             =   3360
      Width           =   1455
   End
   Begin VB.CheckBox chkBreakpoint 
      Caption         =   "Breakpoint"
      Height          =   255
      Left            =   7080
      TabIndex        =   11
      Top             =   1920
      Width           =   1095
   End
   Begin MSComctlLib.ListView lvwCells 
      Height          =   3615
      Left            =   1680
      TabIndex        =   10
      Top             =   480
      Width           =   5295
      _ExtentX        =   9340
      _ExtentY        =   6376
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      HideColumnHeaders=   -1  'True
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.CommandButton cmdChangeTapeSize 
      Caption         =   "Change Tape Size"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   2520
      Width           =   1455
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   495
      Left            =   7080
      TabIndex        =   6
      Top             =   3600
      Width           =   1455
   End
   Begin VB.CommandButton cmdFillTapeWithValue 
      Caption         =   "Fill Tape With a Certain Value"
      Height          =   615
      Left            =   7080
      TabIndex        =   5
      Top             =   1200
      Width           =   1455
   End
   Begin VB.CommandButton cmdFillTapeRandomly 
      Caption         =   "Fill Tape Randomly"
      Height          =   615
      Left            =   7080
      TabIndex        =   4
      Top             =   480
      Width           =   1455
   End
   Begin VB.CommandButton cmdDeleteCell 
      Caption         =   "Delete Cell"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1680
      Width           =   1455
   End
   Begin VB.CommandButton cmdAddCell 
      Caption         =   "Add Cell"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   480
      Width           =   1455
   End
   Begin VB.CommandButton cmdEditCell 
      Caption         =   "Edit Cell"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1080
      Width           =   1455
   End
   Begin VB.Label lblSize 
      AutoSize        =   -1  'True
      Caption         =   "Size:"
      Height          =   210
      Left            =   5640
      TabIndex        =   9
      Top             =   240
      Width           =   360
   End
   Begin VB.Label lblLoading 
      AutoSize        =   -1  'True
      Caption         =   "Loading Tape Cells..."
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   210
      Left            =   3360
      TabIndex        =   8
      Top             =   1800
      Width           =   1710
   End
   Begin VB.Label lblCells 
      AutoSize        =   -1  'True
      Caption         =   "Tape Cells"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   210
      Left            =   1680
      TabIndex        =   7
      Top             =   240
      Width           =   870
   End
End
Attribute VB_Name = "frmEditTape"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Used to hold information on the latest error raised by the DFA.
Private mblnErrorRaised As Boolean
Private mdeLatestErrorNumber As DFAError
Private mstrLatestErrorDescription As String
Private mstrLatestErrorSource  As String

Public WithEvents gclsDFA As clsDFA
Attribute gclsDFA.VB_VarHelpID = -1

Private Sub chkBreakpoint_Click()
    If (Not (lvwCells.SelectedItem Is Nothing)) Then
        If (chkBreakpoint.Value = 1) Then
            ' Set the breakpoint.
            gclsDFA.TapeCellsBreakPoint(lvwCells.SelectedItem.Index) = True
            lvwCells.SelectedItem.Bold = True
            lvwCells.SelectedItem.ForeColor = vbRed
        Else
            ' Unset the breakpoint.
            gclsDFA.TapeCellsBreakPoint(lvwCells.SelectedItem.Index) = False
            lvwCells.SelectedItem.Bold = False
            lvwCells.SelectedItem.ForeColor = vbBlack
        End If
    End If
End Sub

Private Sub cmdAddCell_Click()
    Dim strNewCell As String
    
    strNewCell = InputBox("Please enter the new cell value" & IIf(gclsDFA.TextualTapeCellValues = False, " (either 0 or 1)", "") & ":", "Add Cell", "0")
    
    ' User pressed cancel.
    If ((strNewCell = "") And (gclsDFA.TextualTapeCellValues = False)) Then _
        Exit Sub
    
    If ((gclsDFA.TextualTapeCellValues = False) And (strNewCell <> "0") And (strNewCell <> "1")) Then _
        MsgBox "Invalid cell value; can only be either 0 or 1!", vbExclamation, "DFA Simulation": Exit Sub
    
    gclsDFA.AddTapeCell strNewCell
    
    lvwCells.ListItems.Add , , strNewCell

    lblSize.Caption = "Size: " & gclsDFA.TapeCellCount
    lblSize.Left = (lvwCells.Left + lvwCells.Width) - lblSize.Width

    cmdFillTapeRandomly.Enabled = True
    cmdFillTapeWithValue.Enabled = True
End Sub

Private Sub cmdChangeTapeSize_Click()
    Dim strNewSize As String
    Dim intNewSize As Integer
    Dim blnErrorRaised As Boolean
    
    On Error GoTo ErrHandler
    
    blnErrorRaised = False
    
    strNewSize = InputBox("Please enter a new tape size:", "Change Tape Size", gclsDFA.TapeCellCount)
    
    If (strNewSize <> "") Then
        intNewSize = CInt(strNewSize)
    
        ' An invalid size has been entered.
        If ((blnErrorRaised = True) Or (intNewSize <= 0)) Then _
            MsgBox "An invalid tape size has been entered!", vbExclamation, "DFA Simulation": Exit Sub
        
        If ((gclsDFA.SimulationStatus = ssPaused) And _
            (intNewSize < IIf(gclsDFA.CurrentTapePosition > 0, gclsDFA.CurrentTapePosition, 1))) Then
            If (MsgBox("The new tape size is " & intNewSize & ", while the current tape position is " & IIf(gclsDFA.CurrentTapePosition > 0, gclsDFA.CurrentTapePosition, 1) & "." & vbCrLf & _
                "This means the new tape position will be set to " & intNewSize & ". Are you sure you want to continue?", vbQuestion Or vbYesNo, "DFA Simulation") = vbNo) Then _
                Exit Sub
        End If
        
        Me.MousePointer = vbHourglass
        gclsDFA.TapeCellCount = intNewSize
        Call Form_Load
        Me.MousePointer = vbDefault
    
        lblSize.Caption = "Size: " & gclsDFA.TapeCellCount
        lblSize.Left = (lvwCells.Left + lvwCells.Width) - lblSize.Width
    End If
    
    Exit Sub
    
ErrHandler:
    blnErrorRaised = True
    
    Resume Next
End Sub

Private Sub cmdDeleteCell_Click()
    If Not (lvwCells.SelectedItem Is Nothing) Then
        If ((gclsDFA.SimulationStatus = ssPaused) And _
        ((gclsDFA.TapeCellCount - 1) < IIf(gclsDFA.CurrentTapePosition > 0, gclsDFA.CurrentTapePosition, 1))) Then
            If (MsgBox("After deleting this tape cell, the new tape size will be " & (gclsDFA.TapeCellCount - 1) & ", while the current tape position is " & IIf(gclsDFA.CurrentTapePosition > 0, gclsDFA.CurrentTapePosition, 1) & "." & vbCrLf & _
                "This means the new tape position will be set to " & (gclsDFA.TapeCellCount - 1) & ". Are you sure you want to continue?", vbQuestion Or vbYesNo, "DFA Simulation") = vbNo) Then _
                Exit Sub
        Else
            If (MsgBox("Are you sure you want to delete this cell?", vbQuestion Or vbYesNo, "DFA Simulation") = vbNo) Then _
                Exit Sub
        End If

        gclsDFA.DeleteTapeCell lvwCells.SelectedItem.Index

        cmdEditCell.Enabled = False
        cmdDeleteCell.Enabled = False
    
        If (gclsDFA.TapeCellCount = 0) Then
            cmdFillTapeRandomly.Enabled = False
            cmdFillTapeWithValue.Enabled = False
        End If

        lvwCells.ListItems.Remove lvwCells.SelectedItem.Index
    
        lblSize.Caption = "Size: " & gclsDFA.TapeCellCount
        lblSize.Left = (lvwCells.Left + lvwCells.Width) - lblSize.Width
    End If
End Sub

Private Sub cmdEditCell_Click()
    Dim strNewCell As String
    
    If Not (lvwCells.SelectedItem Is Nothing) Then
        strNewCell = InputBox("Please edit the selected cell" & IIf(gclsDFA.TextualTapeCellValues = False, " (either 0 or 1)", "") & ":", "Edit Cell", lvwCells.SelectedItem.Text)
        
        ' User pressed cancel.
        If (strNewCell = "") Then _
            Exit Sub
        
        If ((gclsDFA.TextualTapeCellValues = False) And (strNewCell <> "0") And (strNewCell <> "1")) Then _
            MsgBox "Invalid cell value; can only be either 0 or 1!", vbExclamation, "DFA Simulation": Exit Sub
        
        gclsDFA.TapeCells(lvwCells.SelectedItem.Index) = strNewCell
        
        lvwCells.SelectedItem.Text = strNewCell
    End If
End Sub

Private Sub cmdFillTapeRandomly_Click()
    If (gclsDFA.TapeCellCount > 0) Then
        Me.MousePointer = vbHourglass
        gclsDFA.FillTapeRandomly
        Call Form_Load
        Me.MousePointer = vbDefault
    End If
End Sub

Private Sub cmdFillTapeWithValue_Click()
    Dim strNewValue As String
    
    If (gclsDFA.TapeCellCount > 0) Then
        strNewValue = InputBox("Please enter the value to fill the tape with" & IIf(gclsDFA.TextualTapeCellValues = False, " (either 0 or 1)", "") & ":", "Fill Tape With Value", "0")

        ' User pressed cancel.
        If ((strNewValue = "") And (gclsDFA.TextualTapeCellValues = False)) Then _
            Exit Sub
        
        If ((gclsDFA.TextualTapeCellValues = False) And (strNewValue <> "0") And (strNewValue <> "1")) Then _
            MsgBox "Invalid cell value; can only be either 0 or 1!", vbExclamation, "DFA Simulation": Exit Sub
        
        Me.MousePointer = vbHourglass
        gclsDFA.FillTapeWithValue strNewValue
        Call Form_Load
        Me.MousePointer = vbDefault
    End If
End Sub

Private Sub cmdSwitchEditMode_Click()
    If (cmdSwitchEditMode.Caption = "Switch to Pure Text Tape Edit Mode") Then
        ' Switch to Pure Text Tape edit mode.
        
        lvwCells.Visible = False
        'lblCells.Visible = False
        
        lblLoading.Visible = True
        
        cmdAddCell.Enabled = False
        cmdEditCell.Enabled = False
        cmdDeleteCell.Enabled = False
        cmdFillTapeRandomly.Enabled = False
        cmdFillTapeWithValue.Enabled = False
        cmdChangeTapeSize.Enabled = False
        chkBreakpoint.Enabled = False
        
        txtTapeCells.Visible = False
        
        Me.MousePointer = vbHourglass
        txtTapeCells.Text = gclsDFA.SaveTapeIntoText(True)
        Me.MousePointer = vbDefault
        
        lblLoading.Visible = False
        txtTapeCells.Visible = True
        
        cmdSwitchEditMode.Caption = "Switch to List and Buttons Edit Mode"
        
    Else
        ' Switch to List and Buttons Tape edit mode.
        
        mblnErrorRaised = False
        gclsDFA.LoadTapeFromText ("Textual Tape Cells = " & gclsDFA.TextualTapeCellValues & vbCrLf & _
            "Tape Cell Count = " & gclsDFA.TapeCellCount & vbCrLf & "Tape Cells:" & vbCrLf & txtTapeCells.Text)
        
        If (mblnErrorRaised = True) Then
            MsgBox "An error was raised while switching to List and Buttons Tape Edit Mode:" & vbCrLf & vbCrLf & _
                "Number: " & mdeLatestErrorNumber & vbCrLf & _
                "Description: " & mstrLatestErrorDescription & vbCrLf & _
                "Source: " & mstrLatestErrorSource, vbExclamation, "DFA Simulation"
            mblnErrorRaised = False
            Exit Sub
        End If
        
        Call Form_Load
        
        cmdSwitchEditMode.Caption = "Switch to Pure Text Tape Edit Mode"
    End If
End Sub

Private Sub Form_Load()
    Dim i As Integer
    
    lvwCells.Visible = False
    lblCells.Visible = False
    lblSize.Visible = False
    
    lblLoading.Visible = True
    
    cmdAddCell.Enabled = False
    cmdEditCell.Enabled = False
    cmdDeleteCell.Enabled = False
    cmdFillTapeRandomly.Enabled = False
    cmdFillTapeWithValue.Enabled = False
    cmdChangeTapeSize.Enabled = False
    chkBreakpoint.Enabled = False
    
    txtTapeCells.Visible = False
    
    Me.MousePointer = vbHourglass
    
    lvwCells.ColumnHeaders.Clear
    lvwCells.ColumnHeaders.Add , , "Cell Value", lvwCells.Width - 5
    
    lvwCells.ListItems.Clear
    
    For i = 1 To gclsDFA.TapeCellCount
        lvwCells.ListItems.Add , , gclsDFA.TapeCells(i)
        If (gclsDFA.TapeCellsBreakPoint(i) = True) Then _
            lvwCells.ListItems(i).Bold = True: lvwCells.ListItems(i).ForeColor = vbRed
    Next i
    
    lvwCells.Visible = True
    lblCells.Visible = True
    lblSize.Visible = True
    
    lblSize.Caption = "Size: " & gclsDFA.TapeCellCount
    lblSize.Left = (lvwCells.Left + lvwCells.Width) - lblSize.Width
    
    lblLoading.Visible = False
    
    cmdAddCell.Enabled = True
    
    If (gclsDFA.TapeCellCount > 0) Then
        cmdFillTapeRandomly.Enabled = True
        cmdFillTapeWithValue.Enabled = True
    End If
    
    cmdChangeTapeSize.Enabled = True
    
    Me.MousePointer = vbDefault
End Sub


Private Sub cmdClose_Click()
    If (cmdSwitchEditMode.Caption = "Switch to List and Buttons Edit Mode") Then
        ' Switch to List and Buttons mode first (in order to check if the
        ' tape text entered by the user is valid).
        Call cmdSwitchEditMode_Click
        
        If (cmdSwitchEditMode.Caption = "Switch to List and Buttons Edit Mode") Then _
            Exit Sub
    End If
    Unload Me
End Sub

Private Sub lvwCells_Click()
    If (Not (lvwCells.SelectedItem Is Nothing)) Then
        cmdEditCell.Enabled = True
        cmdDeleteCell.Enabled = True
        chkBreakpoint.Enabled = True
        
        chkBreakpoint.Value = Abs(gclsDFA.TapeCellsBreakPoint(lvwCells.SelectedItem.Index))
    End If
End Sub

Private Sub lvwCells_DblClick()
    Call lvwCells_Click
    
    If (gclsDFA.TextualTapeCellValues = True) Then
        ' Edit the selected cell value.
        Call cmdEditCell_Click
    Else
        ' Toggle the selected cell value (0 to 1, 1 to 0).
        If Not (lvwCells.SelectedItem Is Nothing) Then
            If (lvwCells.SelectedItem.Text = "0") Then
                gclsDFA.TapeCells(lvwCells.SelectedItem.Index) = "1"
                lvwCells.SelectedItem.Text = "1"
            Else
                gclsDFA.TapeCells(lvwCells.SelectedItem.Index) = "0"
                lvwCells.SelectedItem.Text = "0"
            End If
        End If
    End If
End Sub

Private Sub lvwCells_GotFocus()
    Call lvwCells_Click
End Sub

Private Sub lvwCells_KeyPress(KeyAscii As Integer)
    Call lvwCells_Click
End Sub

Private Sub lvwCells_KeyUp(KeyCode As Integer, Shift As Integer)
    Call lvwCells_Click
End Sub

Private Sub lvwCells_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Call lvwCells_Click
End Sub


Private Sub gclsDFA_ErrorRaised(Error As DFAError, Description As String, Source As String)
    mblnErrorRaised = True
    mdeLatestErrorNumber = Error
    mstrLatestErrorDescription = Description
    mstrLatestErrorSource = Source
End Sub
